#include "Info.h"

FunctionInfo::FunctionInfo(FuncDef *expr, ClassInfoPtr klass)
: VarInfo(expr->pident_, nullptr), block(expr->block_), klass(klass)
{
	ListType *funArgs = new ListType();
	type = make_shared<Fun>(expr->type_, funArgs);
	arguments.reserve(expr->listarg_->size());
	for (auto arg : *expr->listarg_) {
		VarInfoPtr var = make_shared<VarInfo>((Ar*)arg);
		var->ident->var = var;
		arg->pident_->var = var;
		arguments.emplace_back(var);
		funArgs->emplace_back(arg->type_);
	}
}

Binding::Binding(shared_ptr<Binding> parent)
	: variables(parent ? &parent->variables : nullptr),
	classes(parent ? &parent->classes : nullptr, &variables),
	functions(parent ? &parent->functions : nullptr, &variables),
	parent(parent)
{

}



ClassInfo::ClassInfo(PIdent *ident, BindingPtr parent /*= nullptr*/)
	: VarInfo(ident),
	Binding(parent)
{
	type = make_shared<ClassT>(ident->clone());
	type->binding = parent;
};

Scope::Scope()
	: currentClass()
{
}

