#!/bin/bash
t=0
RED='\033[0;31m'
GREEN='\033[0;32m'
NONE='\033[0m'

function red {
	echo -e "${RED}$@${NONE}"
}
function green {
	echo -e "${GREEN}$@${NONE}"
}

make -j8 && for i in lat/lattests/good/*.lat; do
	t=$((t+1))
	(./latc "$i" &>/dev/null);
	if ! [ $? -eq 0 ]; then
		red "FAIL $i";
		./latc "$i"
		exit 1;
	fi
done && green good OK && for i in lat/lattests/bad/*.lat; do
	t=$((t+1))
	(./latc "$i" &>/dev/null);
	if [ $? -eq 0 ]; then
		red "FAIL $i";
		./latc "$i"
		exit 1;
	fi
done && green "OK: $t tests passed!" && for ext in `ls lat/lattests/extensions`; do
	ok=1
	for i in lat/lattests/extensions/$ext/*.lat; do
		(./latc "$i" &>/dev/null);
		if ! [ $? -eq 0 ]; then
			red "$ext fails on $i";
			./latc "$i"
			ok=0;
			break;
		fi
	done
	if [ $ok -eq 1 ]; then
		green "OK: $ext passed!"
	fi
done